package cn.com.tenlion.systembase.util.fullsync;

import cn.com.tenlion.systembase.pojo.dtos.comprehensivecenter.ComprehensiveCenterDTO;
import cn.com.tenlion.systembase.pojo.dtos.institution.InstitutionDTO;
import cn.com.tenlion.systembase.pojo.dtos.keyplace.KeyPlaceDTO;
import cn.com.tenlion.systembase.pojo.vos.comprehensivecenter.ComprehensiveCenterVO;
import cn.com.tenlion.systembase.pojo.vos.institution.InstitutionVO;
import cn.com.tenlion.systembase.pojo.vos.keyplace.KeyPlaceVO;
import cn.com.tenlion.systembase.service.institution.IInstitutionService;
import cn.com.tenlion.systembase.service.keyplace.IKeyPlaceService;
import com.alibaba.fastjson.JSONObject;
import ink.wgink.exceptions.SearchException;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 表单全量数据同步
 * 接收数据整合系统发来的全量数据同步命令, 向数据整合系统发送表单的全部数据
 */
@Component
public class FullSyncC0011 implements ApplicationEventPublisherAware {

    private ApplicationEventPublisher applicationEventPublisher;
    @Autowired
    private IKeyPlaceService keyPlaceService;
    @Autowired
    KafkaTemplate kafkaTemplate;

    public FullSyncC0011() {}

    @KafkaListener(topics = "C0011FullSync")
    public void message(ConsumerRecord<?, ?> record) {
        System.out.println("收到全量同步命令");
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        System.out.println(jsonObject.toJSONString());// 表单编号
        System.out.println(jsonObject.getString("tableNumber"));// 表单编号
        System.out.println(jsonObject.getInteger("tableDataCount"));// 整合系统数据量
        /**
         * 1 . 查询本地数据的数量 , 如果本地数据量 > 整合系统数据量
         * 2 . 查询数据库中所有的事件列表
         * 3 . 遍历事件, 封装数据
         * 4 . 发送新增案件消息
         */
        Map<String, Object> params = new HashMap<>();
        List<KeyPlaceDTO> keyPlaceDTOList = keyPlaceService.list(params);
        System.out.println(keyPlaceDTOList.size());
        if(null != keyPlaceDTOList && keyPlaceDTOList.size() > 0) {
            for(KeyPlaceDTO keyPlaceDTO: keyPlaceDTOList) {
                KeyPlaceVO keyPlaceVO = setData(keyPlaceDTO);
                keyPlaceService.saveKafka(keyPlaceDTO.getKeyPlaceId(), keyPlaceVO);
            }
        }
    }

    @KafkaListener(topics = "C0011")
    public void messageMsg(ConsumerRecord<?, ?> record) {
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        Map<String, Object> params = new HashMap<>();
        if(!"delete".equals(jsonObject.getString("action"))) {
            KeyPlaceDTO keyPlaceDTO = keyPlaceService.get(jsonObject.getString("uid"));
            KeyPlaceVO keyPlaceVO = setData(keyPlaceDTO);
            keyPlaceService.saveKafka(keyPlaceDTO.getKeyPlaceId(), keyPlaceVO);
        }else {
            keyPlaceService.deleteKafka(jsonObject.getString("uid"));
        }
    }

    private KeyPlaceVO setData(KeyPlaceDTO keyPlaceDTO) {
        if(null == keyPlaceDTO) {
            throw new SearchException("当前对象为空,请注意查看");
        }
        KeyPlaceVO keyPlaceVO = new KeyPlaceVO();
        keyPlaceVO.setPlaceName(keyPlaceDTO.getPlaceName());
        keyPlaceVO.setPlaceTypeName(keyPlaceDTO.getPlaceTypeName());
        keyPlaceVO.setDetailTypeName(keyPlaceDTO.getDetailTypeName());
        keyPlaceVO.setAddress(keyPlaceDTO.getAddress());
        keyPlaceVO.setAreaCode(keyPlaceDTO.getAreaCode());
        keyPlaceVO.setLongitude(keyPlaceDTO.getLongitude());
        keyPlaceVO.setLatitude(keyPlaceDTO.getLatitude());
        keyPlaceVO.setGrid(keyPlaceDTO.getGrid());
        return keyPlaceVO;
    }

    @Override
    public void setApplicationEventPublisher(ApplicationEventPublisher applicationEventPublisher) {
        this.applicationEventPublisher = applicationEventPublisher;
    }

}